﻿/**
 * RadicalChatService
 * Copyright Jaromir Sivic 2009 
 */

using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

/// <summary>
/// Class chatroom
/// </summary>
public class ChatRoom
{
    //room uid
    public string UID = "";
    /// <summary>
    /// Return room unique ID
    /// </summary>
    /// <returns></returns>
    public string getUID() { return UID; }
    //when room will be checked next time
    public int nextCheck = -1;
    /// <summary>
    /// Return time in seconds, when room will next time call onCheckRooms
    /// </summary>
    /// <returns></returns>
    public int getNextCheck() { return nextCheck; }
    /// <summary>
    /// Set time in seconds, when room will next time call onCheckRooms
    /// </summary>
    /// <param name="value"></param>
    public void setNextCheck(int value) { nextCheck = value; }
    //name of the room
    public string roomName = "";
    /// <summary>
    /// Return room name
    /// </summary>
    /// <returns></returns>
    public string getRoomName() { return roomName; }
    /// <summary>
    /// Set room name
    /// </summary>
    /// <param name="value"></param>
    public void setRoomName(string value) { roomName = value; }
    //description - never used by stream server
    public string description = "";
    /// <summary>
    /// Return description.
    /// </summary>
    /// <returns></returns>
    public string getDescription() { return description; }
    /// <summary>
    /// Set description.
    /// </summary>
    /// <param name="value"></param>
    public void setDescription(string value) { description = value; }
    //if room is closed or not
    public Boolean roomClosed = false;
    //users count
    public int usersCount = 0;
    /// <summary>
    /// Return count of users in the room.
    /// </summary>
    /// <returns></returns>
    public int getUsersCount() { return usersCount; }
    //chat text
    public string chatText = "";
    /// <summary>
    /// Universal command
    /// </summary>
    public string commands = "";
    /// <summary>
    /// Additional variables serialized into this string
    /// </summary>
    public string propertiesRO = "";

	public ChatRoom()
	{
		
	}

    /// <summary>
    /// Close room and reject all clients
    /// </summary>
    public void CloseRoom()
    {
        roomClosed = true;
    }

    /// <summary>
    /// This method will send text message to all clients in chat room
    /// </summary>
    /// <param name="color"></param>
    /// <param name="userName"></param>
    /// <param name="text"></param>
    public void SendRoomMessage(string fromUserName, string color, string text)
    {
        chatText += fromUserName + "~~_ALL~~" + color + "~~" + text + "~!~";
    }

    /// <summary>
    /// Add new command to the commands array
    /// </summary>
    /// <param name="commandName"></param>
    /// <param name="parameters"></param>
    private void addCommand(string commandName, string[] parameters)
    {
        //test if command is null
        if (commands == null)
        {
            commands = "";
        }
        //create outparams
        string outparams = "";
        //serialize parameters into outparams
        if (parameters != null)
        {
            foreach (string parameter in parameters)
            {
                outparams += Const.SEPARATOR + parameter;
            }
        }
        //create command
        commands += commandName + outparams + Const.NEWLINE;
    }
}
