<?php
  /*************************************************************
   *                   Chat For 4
   *
   *                   START HERE
   *     HERE ARE DEFINED CHAT RULES AND CHAT BEHAVIOR
   ************************************************************/
?>
<?php
/**
 * Radical Flash Chat
 * ChatFor4
 *
 * LICENSE
 *
 * This source file is subject of Jaromir Sivic's ownership
 * and the commercial license on http://www.cze.cz.
 * It is not allowed to redistribute or modify source code
 * of this file. It is also not allowed to use any part
 * of the following Radical Chat source code in another projects.
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to radicalchat@cze.cz and you will be issued with a copy immediately.
 *
 * @category   Radical Chat
 * @copyright  Jaromir Sivic 2009
 * @license    http://www.cze.cz commercial license
 */
?>
<?php
    require_once("serviceconfiguration.php");
?>
<?php

    /**
     * !!!!!!!!
     * Please do not access variables and properties
     * from classes "Client", "Stream", "ChatRoom" directly.
     * Use setters, getters and implemented public functions.
     */

     //set the encoding of this php file script
     //Configuration::$LOCAL_ENCODING = "cp1250";


    class MyConstants
    {
        public static $MaximumClients = 4;
    }



    /**
     * OnApplicationStarted event is triggered when Radical Bridge
     * application is loaded into the stream server memory.
     */
    function _onApplicationStarted()
    {
    	Logger::func("onApplictionStarted");
    }





    /**
     * OnApplicationStopped event is triggered a few moments before
     * Radical Bridge application is unloaded from the stream server memory.
     * Typically it is just before the stream server is properly terminated,
     * or also in case that there are no connected clients for a long time.
     * WARNING: onApplicationStopped is not triggered if the stream server crashes down.
     */
    function _onApplicationStopped()
    {
    	Logger::func("onApplicationStopped");
    }




    /**
     * OnClientWantsToConnect event is triggered when a client attempts
     * to connect to the Radical Bridge (before he/she is assigned into
     * the chat room). Developers should always implement this function.
     * “AcceptConnection” or “RejectConnection” method must be called
     * somewhere in the body of this function.
     *
     * @param Client $client - client who wants to connect to the system
     */
    function _onClientWantsToConnect(&$client)
    {
        //create persistent object
        $po = new PersistentObject($client->getRoomUID(),true);
        //test if there is a free space in the room
        if($po->vars["usersCount"]>=MyConstants::$MaximumClients)
        {
            //if there is no free space in the room, then reject client
            $po->close();
            $client->RejectConnection();
            return;
        }
        //else increse count of users which are currently in the roon
        else
        {
            $po->vars["usersCount"]++;
        }

        //pass through array of users which are in the room
        for($a=0;$a<MyConstants::$MaximumClients;$a++)
        {
            //try to find a free space for video player
            if($po->vars["User".$a]==null)
            {
                //if free space for video player was found
                //then allocate it for the $client
                $po->vars["User".$a] = $client->getUID();
                $po->save();
                $po->close();

                //get room skin manipulator
                $ssc = $client->getStreamServerCommands();
                $skin = $ssc->room_getSkin($client->getRoomUID());
                //create username label
                $skin->updateSkinObjectFromFile("dynamicskin/username.xml",
                                                array("name" => $a,
                                                      "left" => $a*200,
                                                      "userNickName" => $client->getNickName()));
                //create status label
                $skin->updateSkinObjectFromFile("dynamicskin/status.xml",
                                                array("name" => $a,
                                                      "left" => $a*200,
                                                      "color" => "#990000",
                                                      "status" => "off"));

                //accept client's connection
                $client->AcceptConnection();
                //send room message
                $client->SendRoomMessage(
                        "Admin", "000000", "User \"" . $client->getNickName() .
                        "\" has entered the room.");
                return;
            }
        }
    }







    /**
     * OnClientConnectionWasAccepted event comes after onClientWantsToConnect,
     * but only if a client was accepted by â€śAcceptConnectionâ€ť method. Usually
     * it is not necessary to implement the body of this function.
     *
     * @param Client $client client who was accepted and entered
     * the chat successfully
     */
    function _onClientConnectionWasAccepted(&$client)
    {
        Logger::func("onClientConnectionWasAccepted");
    }







    /**
     * OnClientConnectionWasRejected event comes after onClientWantsToConnect
     * If the client was fired (kicked out) by â€śRejectConnectionâ€ť method.
     * Usually it is not necessary to implement the body of this function.
     *
     * @param Client $client handler of the client which connection
     * was rejected in the onClientWantsToConnect event
     */
    function _onClientConnectionWasRejected($client)
    {
        Logger::func("onClientConnectionWasRejected");
    }








    /**
     * OnClientDisconnected event occurs when the client is disconnected
     * by “RejectConnection” or if a connection is somehow terminated,
     * for example because of network malfunction or because the client
     * turned off the computer or closed the web browser.
     *
     * @param Client $client handler of the client who has disconnected
     * himself from the server. This parameter is not transfered back
     * to the stream server.
     * @param ChatRoom $room handler to the ChatRoom, where client
     * belonged before he disconnected himself. This parameter is
     * transfered back to the stream server.
     */
    function _onClientDisconnected($client, &$room = null)
    {
        //WARNING room can be null if user was rejected
        //        before he was assigned into the room

        //send the message that client left the room
        $room->SendRoomMessage("Admin","000000","User " .
                               $client->getNickName() . " left the room");


        //attach persistent object
        $po = new PersistentObject($room->getUID(),true);

        if($room!=null)
        {
            //pass through the array of the users
            //which are currently in the room
            for($a=0;$a<MyConstants::$MaximumClients;$a++)
            {
                //try to index of client $client
                if(($po->vars["User".$a]!=null) &&
                   ($po->vars["User".$a]==$client->getUID()))
                {
                    //if index was found

                    //decrement users count
                    $po->vars["usersCount"]--;
                    $po->vars["User".$a] = null;

                    //get room skin manipulator
                    $ssc = $room->getStreamServerCommands();
                    $skin = $ssc->room_getSkin($room->getUID());
                    //delete usernicname label
                    $skin->deleteAllSkinObjectUpdates("Text".$a);
                    //delete status text
                    $skin->deleteAllSkinObjectUpdates("StatusText".$a);
                    //delete video player
                    $skin->deleteAllSkinObjectUpdates("MyVideo".$a);

                    //save persistent object
                    $po->save();
                    $po->close();
                    return;
                }
            }
        }
    }








    /**
     * OnClientWantsToStartStreaming event is triggered every time when any
     * client wants to publish live audio or video stream.
     * Mostly it is a live video from a web camera.
     *
     * @param Client $client handler of the client who wants to publish
     * the stream
     * @param Stream $stream stream descriptor
     */
    function _onClientWantsToStartStreaming(&$client, $stream)
    {
        //client can start streaming
        $client->setStreamingAccepted();
        
        //pass through the array of users
        //which are currently in the room
        for($a=0;$a<MyConstants::$MaximumClients;$a++)
        {
            //attach persistent object
            $po = new PersistentObject($client->getRoomUID(),true);
            //try to find the index of user $client
            if(($po->vars["User".$a]!=null) &&
               ($po->vars["User".$a]==$client->getUID()))
            {
                //if index was found

                //load xml data from property stream information
                $xml = simplexml_load_string($stream->getInformation());

                //get room skin manipulator
                $ssc = $client->getStreamServerCommands();
                $skin = $ssc->room_getSkin($client->getRoomUID());

                //set interval for "onCheckClients" method,
                //where this client will be checked every 5 seconds
                //to test if he is still streaming
                $ssc->client_setNextCheckDefaultValue($client->getUID(), 5);
                $po->vars["User_".$client->getUID()."_isstreaming"] = true;

                //if user is publishing audio only
                if($xml->title=="Audio only")
                {
                    //update status label to inform that
                    //user is publishing only audio
                    $skin->updateSkinObjectFromFile("dynamicskin/status.xml",
                                                    array("name" => $a,
                                                          "left" => $a*200,
                                                          "color" => "#117799",
                                                          "status" => "Audio"));
                    //make video player invisible
                    //set its left position to -10000
                    $skin->updateSkinObjectFromFile("dynamicskin/videoplayer.xml",
                                                array("name" => $a,
                                                      "left" => -1000,
                                                      "streamUID" => $client->getRoomUID().Constants::$PATH_SEPARATOR.
                                                                     $client->getUID().Constants::$PATH_SEPARATOR."Stream1"));
                }
                else
                {
                    //update status label
                    //there should be no text
                    $skin->updateSkinObjectFromFile("dynamicskin/status.xml",
                                                    array("name" => $a,
                                                          "left" => $a*200,
                                                          "color" => "#00AA00",
                                                          "status" => ""));

                    //make video player visible
                    $skin->updateSkinObjectFromFile("dynamicskin/videoplayer.xml",
                                                array("name" => $a,
                                                      "left" => $a*200,
                                                      "streamUID" => $client->getRoomUID().Constants::$PATH_SEPARATOR.
                                                                     $client->getUID().Constants::$PATH_SEPARATOR."Stream1"));
                }

                //save persistent object
                $po->save();
                $po->close();
                return;
            }
        }
    }






    /**
     * OnClientStoppedStreaming is a notification event that indicates
     * that the client stopped streaming.
     *
     * @param Client $client handler of the client who stopped streaming
     * @param Stream $stream stream descriptor
     */
    function _onClientStoppedStreaming(&$client, $stream)
    {
        //attach persistent object
        $po = new PersistentObject($client->getRoomUID(),true);
        //save that user is not streaming any more
        $po->vars["User_".$client->getUID()."_isstreaming"] = false;
        $po->save();
        $po->close();
    }







    /**
     * OnClientWantsToPlayStream event is triggered when some client
     * attempts to play live audio or video.
     *
     * @param Client $client handler of the client who wants to play
     * some stream
     * @param Stream $stream stream descriptor
     */
    function _onClientWantsToPlayStream(&$client, $stream)
    {
        Logger::func("onClientWantsToPlayStream");
        //accept playing stream
        $client->setPlayStreamAccepted();
    }







    /**
     * OnClientStoppedPlayingStream is a notification event triggered
     * when some client stopped playing live audio or video.
     *
     * @param Client $client handler of the client who stopped playing
     * the stream
     * @param Stream $stream stream descriptor
     */
    function _onClientStoppedPlayingStream(&$client, $stream)
    {
        Logger::func("onClientStoppedPlayingStream");
    }







    /**
     * OnClientSendMessage function is called every time when a client sends
     * a text message, but only in case that the client's flag
     * dispatchEventIfClientSendTextMessage is set to true.
     *
     * @param Client $client handler of the client who is sending the
     * message
     * @param sstring $toUID UID of the recipient
     * @param sstring $color the color of the message
     * @param sstring $message the text of the message
     */
    function _onClientSendMessage(&$client,$toUID,$color,$message)
    {
        Logger::func("onClientSendMessage");
        Logger::info($message);
        $prefix = "prefix ";
        $postfix = " postfix. This message was altered on the fly.".
        $client->SendPrivateMessage($client->getNickName(), $toUID, $color,
                $prefix . $message . $postfix);
    }







    /**
     * OnCheckClients - This event is executed at a periodic
     * time interval, which depends on the property NextCheck of each client
     * in the system. Every one second Radical Bridge decrements NextCheck
     * value of each client in all stream server chat rooms by one. When
     * NextCheck value is equal to 0, client's manipulator (handler) is pushed
     * to the associative array and passed to the onCheckClients event
     * there the property NextCheck must be reset, otherwise the concrete
     * client will never more call onCheckClients again. This function is very
     * useful for such systems, where on the beginning each user has an account
     * with some amount of money or credits and later, if he/she runs
     * out of credit, then his/her connection to the chat is terminated.
     *
     * @param array[int]Client $clients array of handlers of the clients which
     * has to be checked.
     */
    function _onCheckClients(&$clients)
    {
        foreach($clients as $client)
        {
            //cast to client is here only because we need code insight
            //or intellisense when typing the code
            $client = Client::castToClient($client);

            //attach persistent object
            $po = new PersistentObject($client->getRoomUID(),true);
            //if user is not streaming anymore then
            if($po->vars["User_".$client->getUID()."_isstreaming"] == false)
            {
                //pass through the array of users
                //currently presented in the room
                for($a=0;$a<MyConstants::$MaximumClients;$a++)
                {
                    //try to find the index of user $client
                    if(($po->vars["User".$a]!=null) &&
                       ($po->vars["User".$a]==$client->getUID()))
                    {
                        //if index was found

                        //get skin manipulator
                        $ssc = $client->getStreamServerCommands();
                        $skin = $ssc->room_getSkin($client->getRoomUID());

                        //delete "onCheckClients" timer interval for client $client
                        $ssc->client_setNextCheckDefaultValue($client->getUID(), -1);

                        //update status label
                        $skin->updateSkinObjectFromFile("dynamicskin/status.xml",
                                                        array("name" => $a,
                                                              "left" => $a*200,
                                                              "color" => "#990000",
                                                              "status" => "off"));
                    }
                }
            }

            //save persistent object
            $po->save();
            $po->close();
        }
    }







    /**
     * OnUniversalCall event is triggered when custom BasicButton
     * in Radical Flash Chat  application
     * (application in client's web browser) is pressed.
     *
     * @param array[int]Client $clients array of clients
     * @param $senderName action which caused this call,
     * for example button click
     * @param $eventName - name of the event,
     * please see the class ChatEvents
     * @param $value optional parameter
     */
    function _onUniversalCall(&$clients,$senderName,$eventName,$value)
    {
        Logger::func("onUniversalCall");
    }






    /**
     * OnChatRoomCreated event occurs when new chat room is created just
     * before the first client attempts to enter it.
     *
     * @param ChatRoom $room handler of the room which is going to be
     * created
     */
    function _onChatRoomCreated(&$room)
    {
        //try to alter room skin
        $ssc = $room->getStreamServerCommands();
        $skin = $ssc->room_getSkin($room->getUID());

        //create persistent object
        $po = new PersistentObject($room->getUID(),true);
        $po->vars["usersCount"] = 0;

        //create panels for videoplayers
        for($a=0;$a<MyConstants::$MaximumClients;$a++)
        {
            //create videopanel
            $skin->updateSkinObjectFromFile("dynamicskin/videopanel.xml",
                                            array("name" => $a,
                                                  "left" => $a*200));
            $po->vars["User".$a] = null;
        }

        $po->save();
        $po->close();
    }







	/**
	 * OnCheckChatRooms - very similar to onCheckClients, but associative
         * array contains chat room handlers instead of client handlers.
         * This function is very useful for online SMS chats.
	 *
         * @param ChatRoom[] $rooms array of handlers of the chatrooms
         * which need to be checked
	 */
	function _onCheckChatRooms(&$rooms)
	{
		Logger::func("onCheckChatRooms");
		foreach($rooms as $room)
		{
			
		}
	}







    /**
     * OnChatRoomClosed event is invoked when a room is about to close,
     * just after the last client left the room.
     *
     * @param ChatRoom $room handler of the chat room which has been closed
     */
    function _onChatRoomClosed($room)
    {
        
    }




?>
<?php
    //handle service
    require_once("servicehandler.php");
?>